package iscrtavanjeGrafa;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

public class GrafOkvir extends JPanel implements TableModelListener{

    //referenca na trenutnu vrednost modela, podesavamo
    //ga svaki put kada nas GrafTableModel obavesti o nekoj
    //strukturalnoj ili promeni u podacima
   GrafTableModel model;
    
    public GrafOkvir() {
	setBackground(Color.blue);
    }
    
    
    @Override
    public void paint(Graphics g) {

	//najpre cistimo ceo prostor
	g.clearRect(0, 0, getSize().width, getSize().height);
	
	if(model==null)
	    return;
	//cvorove iscrtavamo zutom bojom
	
	for (int i = 0; i <model.cvorovi.size(); i++){
	    g.setColor(Color.black);
	    g.drawString(i+"", model.cvorovi.get(i).x+7, model.cvorovi.get(i).y+14);
	    g.setColor(Color.yellow);
	    g.drawOval(model.cvorovi.get(i).x, model.cvorovi.get(i).y, 20, 20);
	}

	//grane plavom
	g.setColor(Color.blue);
	if (model.mat != null) {
	    for (int i = 0; i < model.mat.length; i++) {
		for (int j = 0; j < model.mat[i].length; j++) {
		    if(i>j)
			continue;
		    if (model.mat[i][j] > 0) {
			int x1=model.cvorovi.get(i).x;
			int y1=model.cvorovi.get(i).y;
			int x2=model.cvorovi.get(j).x;
			int y2=model.cvorovi.get(j).y;
			//iscrtavamo i vrednost tezine grane na sredini grane
			g.drawString(String.valueOf(model.mat[i][j]),(x1+x2)/2, (y1+y2)/2);
			g.drawLine(x1,y1,x2,y2);
		    }
		}
	    }
	}

    }
    
    
    @Override
    public void tableChanged(TableModelEvent e) {
	//ovaj metod se aktivira kada se na modelu pozove
	//fireTableStructureChanged, jer je GrafOkvir podesen
	//kao osluskivac signala koje izbacuje GrafTableModel
        model=(GrafTableModel)e.getSource();
        //kada podesimo novo stanje modela, iscrtavamo ponovo sve
        repaint();
    }

}


